
//Various
#include <queue>
#include <vector>

//Graph
#include <mygraph/mygraph.hpp>


MyGraph components(MyGraph &g){
  
  Vertex u,v;
  int N = num_vertices(g);

  queue<int> Q;
  vector<int> comp(N,-1);
  vector<int> comp_size;

  int nr = 0, max = 0, gc = -1;

  for(int i=0 ; i<N ; i++){

    u = i;

    if(comp[u] == -1){
      
      comp_size.push_back(0);
      comp[u] = nr;
      comp_size[nr]++;
      
      Q.push(i);
      
      while(!Q.empty()){
	
	u = Q.front();

	InEdgeIt ei = in_edges(u,g).first;
	InEdgeIt ee = in_edges(u,g).second;
	
	while(ei != ee){
	  v = source(*ei,g);
	  if(comp[v] == -1){
	    comp[v] = comp[u];
	    Q.push(v);
	    comp_size[nr]++;
	  }
	  ei++;
	}
	
	OutEdgeIt oi = out_edges(u,g).first;
	OutEdgeIt oe = out_edges(u,g).second;
	
	while(oi != oe){
	  v = target(*oi,g);
	  if(comp[v] == -1){
	    comp[v] = comp[u];
	    Q.push(v);
	    comp_size[nr]++;
	  }
	  oi++;
	}
	
	Q.pop();

      }

      if( max < comp_size[nr] ){

	max = comp_size[nr];
	gc = nr;

      }

      nr++;

    }
  }

  int id = 0;

  vector<int> new_id(N);
  
  for(int i=0 ; i<N ; i++){
    
    if(comp[i] == gc){

      new_id[i] = id;

      id++;
    }
  }

  MyGraph GG(id);


  EdgeIt ei = edges(g).first;
  EdgeIt ee = edges(g).second;

  while(ei != ee){

    if(comp[(source(*ei,g))] == gc)
      add_edge(new_id[source(*ei,g)],new_id[target(*ei,g)],GG);

    ei++;

  }

  return(GG);
    
  
  /*
  cout << endl;

  for(int i=0; i < nr; i++)
    cout << i << " " << comp_size[i] << endl;

  cout << endl;

  cout << gc << " " << comp_size[gc] << endl;

  return(nr);

  */

}
