
//STL
#include <vector>
#include <queue>

//Graph
#include <mygraph/mygraph.hpp>

vector<int > shortest_path(const Vertex &v,const MyGraph &g){//cal S

  int N = num_vertices(g);

  queue<int > Q;
  vector<int > d(N,-1);

  d[v] = 0;
  Q.push(v);
      
  while(!Q.empty()){//While not empty

    Vertex u = Q.front();
    Q.pop();

    OutEdgeIt oi = out_edges(u,g).first;
    OutEdgeIt oe = out_edges(u,g).second;
      
    while(oi != oe){
      
      Vertex w = target(*oi,g);
      
      if(d[w] < 0){
	d[w] = d[u] + 1;
	Q.push(w);
	
      }
      
      oi++;
      
    }
    
    InEdgeIt ii = in_edges(u,g).first;
    InEdgeIt ie = in_edges(u,g).second;
    
    while(ii != ie){      
	
     Vertex w = source(*ii,g);
      
      if(d[w] < 0){ 
	d[w] = d[u] + 1;
	Q.push(w);
      }
      
      ii++;
      
    }
  }
  
  return(d);

}

void shortest_path(const Vertex &v, vector<int> &d, vector<list<Vertex> > &pre,
		   list<Vertex> &leaves, const MyGraph &g){//cal S

  int N = num_vertices(g);

  queue<Vertex > Q;
  vector<int > post(N,0);

  d[v] = 0;
  Q.push(v);
      
  while(!Q.empty()){//While not empty

    Vertex u = Q.front();
    Q.pop();

    OutEdgeIt oi = out_edges(u,g).first;
    OutEdgeIt oe = out_edges(u,g).second;
      
    while(oi != oe){
      
      Vertex w = target(*oi,g);
      
      if(d[w] < 0){
	d[w] = d[u] + 1;
	post[u]++;
	Q.push(w);
      }

      if(d[w] == (d[u] + 1))
	pre[w].push_back(u);
       
      oi++;
      
    }
    
    InEdgeIt ii = in_edges(u,g).first;
    InEdgeIt ie = in_edges(u,g).second;
    
    while(ii != ie){
	
     Vertex w = source(*ii,g);
      
      if(d[w] < 0){ 
	d[w] = d[u] + 1;
	post[u]++;
	Q.push(w);
      }

      if(d[w] == (d[u] + 1))
	pre[w].push_back(u);

      ii++;
      
    }
  }
  
  for(int i=0;i<N;i++){
    if(post[i] == 0)
      leaves.push_back(i);
  }

}


int excentricity(const Vertex &v,const MyGraph &g){//cal S

  int N = num_vertices(g);

  
  queue<int > Q;
  vector<int > d(N,-1);
  int max = 0;
  d[v] = 0;
  Q.push(v);
      
  while(!Q.empty()){//While not empty

    Vertex u = Q.front();
    Q.pop();

    OutEdgeIt oi = out_edges(u,g).first;
    OutEdgeIt oe = out_edges(u,g).second;
      
    while(oi != oe){
      
      Vertex w = target(*oi,g);
      
      if(d[w] < 0){
	d[w] = d[u] + 1;
	Q.push(w);
	if(d[w] > max)
	  max = d[w];
	
      }
      
      oi++;
      
    }
    
    InEdgeIt ii = in_edges(u,g).first;
    InEdgeIt ie = in_edges(u,g).second;
    
    while(ii != ie){      
	
     Vertex w = source(*ii,g);
      
      if(d[w] < 0){ 
	d[w] = d[u] + 1;
	Q.push(w);
	if(d[w] > max)
	  max = d[w];
      }
      
      ii++;
      
    }
  }
  
  return(max);

}
